package com.menutoday.controller;

import java.text.SimpleDateFormat;

import javax.servlet.http.HttpSession;

/**
 * 
 * @author igomezuoc
 *
 */
public final class ControllerUtils {

	private static final String MESSAGE_KEY = "message";
	private static final String IS_ERROR_KEY = "isErrorMessage";

	private ControllerUtils() {
		super();
	}

	public static SimpleDateFormat getSimpleDateFormat() {
		return new SimpleDateFormat("MM/dd/yyyy");
	}

	public static void setError(String message, HttpSession session) {
		session.setAttribute(MESSAGE_KEY, message);
		session.setAttribute(IS_ERROR_KEY, true);
	}

	public static void setInfo(String message, HttpSession session) {
		session.setAttribute(MESSAGE_KEY, message);
		session.setAttribute(IS_ERROR_KEY, false);
	}

	public static String getMessage(HttpSession session) {
		String message = null;
		if (session.getAttribute(MESSAGE_KEY) != null) {
			message = (String) session.getAttribute(MESSAGE_KEY);
			session.removeAttribute(MESSAGE_KEY);
		}
		return message;
	}

	public static boolean getIsError(HttpSession session) {
		boolean isError = false;
		if (session.getAttribute(IS_ERROR_KEY) != null) {
			isError = (Boolean) session.getAttribute(IS_ERROR_KEY);
			session.removeAttribute(IS_ERROR_KEY);
		}
		return isError;
	}

}
