package com.menutoday.controller;

import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

/**
 * 
 * @author igomezuoc
 *
 */
@Controller
@RequestMapping("/*")
public class LoginController {

	public LoginController() {
		super();
	}

	@RequestMapping("/login")
	public ModelAndView login() {
		return new ModelAndView("login");
	}

	@RequestMapping("/loginError")
	public ModelAndView loginError(HttpSession session, @RequestParam(defaultValue = "0") int error) {
		ModelAndView result = new ModelAndView("login");
		result.addObject("error", Boolean.TRUE);
		// By default, unexpected error
		String message = "Unexpected error. Please, try again later";
		switch (error) {
		case 1:
			message = "Login denied: Incorrect username/password";
			break;
		case 2:
			message = "Login denied: User is deactivated";
			break;
		default:
			break;
		}
		result.addObject("message", message);
		return result;
	}

}
