package com.menutoday.dao.bo;

import java.net.URI;
import java.util.Comparator;

/**
 * 
 * @author igomezuoc
 *
 */
public class Restaurant implements Comparable<Restaurant>{
	private int id;
	private String nom;
	private String direccio;
	private String poblacio;
	private String pais;
	private URI  thumbail;
	private double preuMenu;
	private int valoracio;
	private String telefon;
	private String serveiDomicili;
	private String comentarisAlta;
	
	public Restaurant(int id, String nom, String direccio, String poblacio,
			URI thumbail, double preu, int valoracio, String telefon, String serveiDomicili, String pais, String comentarisAlta) {
		this.id = id;
		this.nom = nom;
		this.direccio = direccio;
		this.poblacio = poblacio;
		this.thumbail = thumbail;
		this.preuMenu = preu;
		this.valoracio = valoracio;
		this.telefon = telefon;
		this.serveiDomicili = serveiDomicili;
		this.pais = pais;
		this.comentarisAlta = comentarisAlta;
	}
	
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	public String getNom() {
		return nom;
	}
	public void setNom(String nom) {
		this.nom = nom;
	}
	public String getDireccio() {
		return direccio;
	}
	public void setDireccio(String direccio) {
		this.direccio = direccio;
	}
	public URI getThumbail() {
		return thumbail;
	}
	public void setThumbail(URI thumbail) {
		this.thumbail = thumbail;
	}
	public String getPoblacio() {
		return poblacio;
	}
	public void setPoblacio(String poblacio) {
		this.poblacio = poblacio;
	}

	public double getPreuMenu() {
		return preuMenu;
	}

	public void setPreuMenu(double preuMenu) {
		this.preuMenu = preuMenu;
	}

	public int getValoracio() {
		return valoracio;
	}

	public void setValoracio(int valoracio) {
		this.valoracio = valoracio;
	}

	public String getTelefon() {
		return telefon;
	}

	public void setTelefon(String telefon) {
		this.telefon = telefon;
	}

	public String getServeiDomicili() {
		return serveiDomicili;
	}

	public void setServeiDomicili(String serveiDomicili) {
		this.serveiDomicili = serveiDomicili;
	}

	public String getPais() {
		return pais;
	}

	public void setPais(String pais) {
		this.pais = pais;
	}

	public String getComentarisAlta() {
		return comentarisAlta;
	}

	public void setComentarisAlta(String comentarisAlta) {
		this.comentarisAlta = comentarisAlta;
	}

	@Override
	public int compareTo(Restaurant o) {
		return Comparators.NAME.compare(this, o);
	}

	public static class Comparators {
		public static Comparator<Restaurant> NAME = new Comparator<Restaurant> () {
			@Override
			public int compare(Restaurant o1, Restaurant o2) {
				return o1.nom.compareTo(o2.nom);
			}
		};
		
		public static Comparator<Restaurant> VALORACIO = new Comparator<Restaurant> () {
			@Override
			public int compare(Restaurant o1, Restaurant o2) {
				return o2.valoracio - o1.valoracio;
			}
		};
		
		public static Comparator<Restaurant> PREU = new Comparator<Restaurant> () {
			@Override
			public int compare(Restaurant o1, Restaurant o2) {
				return Double.valueOf(o1.preuMenu).compareTo(Double.valueOf(o2.preuMenu));
			}
		};
	}
}
