package com.menutoday.dao.impl;

import java.util.List;

import javax.persistence.Query;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.menutoday.dao.UserDAO;
import com.menutoday.dao.model.User;


@Service
public class UserDAOImpl extends GenericJpaDaoImpl<User> implements UserDAO {

	@SuppressWarnings("unchecked")
	@Override
	@Transactional(propagation = Propagation.MANDATORY)
	public List<User> getAllUsers() {
		Query q = this.em.createQuery("SELECT d from User d");
		return q.getResultList();
	
	}

	@SuppressWarnings("unchecked")
	@Override
	@Transactional(propagation = Propagation.MANDATORY)
	public List<User> loadUserById(String userName) {
		Query q = this.em.createQuery("SELECT d from User d where d.username= :username");
		q.setParameter("username", userName);
		return q.getResultList();
	}
	
}
