package com.menutoday.service.impl;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.menutoday.dao.UserDAO;
import com.menutoday.dao.model.Perfil;
import com.menutoday.dao.model.User;

/**
 * 
 * gome016 07/10/2013
 * 
 */
@Service("userService")
public class UserServiceImpl implements UserDetailsService {

	@Autowired
	private UserDAO userDao;

	public UserServiceImpl() {
		super();
	}

	@Override
	@Transactional(propagation = Propagation.REQUIRED)
	public UserDetails loadUserByUsername(String userName) throws UsernameNotFoundException {
		List<User> list = this.userDao.loadUserById(userName);
		if (list != null && list.size() == 1) {
			User user = list.get(0);
			List<GrantedAuthority> perfils = new ArrayList<GrantedAuthority>();
			
			perfils.add(new Perfil(user.getPerfil()));
			user.setPerfils(perfils);
			return user;

		} else {
			throw new UsernameNotFoundException("User:" + userName + " doesn't exist.");
		}
	}
}
