package com.menutoday.utils;

/**
 * 
 * @author igomezuoc
 *
 */
public enum PerfilType {
	ROLE_USER, ROLE_RESTAURANT, ROLE_ADMINISTRADOR;
	
	public static boolean isRoleRestaurant (PerfilType perfil) {
		return perfil != null && perfil == PerfilType.ROLE_RESTAURANT;
	}
	
	public static boolean isRoleUser (PerfilType perfil) {
		return perfil != null && perfil == PerfilType.ROLE_USER;
	}
	
	public static boolean isRoleAdmin (PerfilType perfil) {
		return perfil != null && perfil == PerfilType.ROLE_ADMINISTRADOR;
	}
	
	public static PerfilType fromString (String perfilName) {
		if (perfilName.toLowerCase().equals(ROLE_ADMINISTRADOR.toString().toLowerCase())) {
			return ROLE_ADMINISTRADOR;
		} else if (perfilName.toLowerCase().equals(ROLE_RESTAURANT.toString().toLowerCase())) {
			return ROLE_RESTAURANT;
		} else if  (perfilName.toLowerCase().equals(ROLE_USER.toString().toLowerCase())) {
			return ROLE_USER;
		} else {
			return null;
		}
	}
}
